Summary: Generator Tools for Coding SOAP/XML Web Services in C and C++
Name: gsoap-opensslv1-static
Version: 2.7.15
Release: 1%{?dist}

License: GPLv2+ with exceptions
Group: Development/Tools
URL: http://gsoap2.sourceforge.net/
Source: http://downloads.sourceforge.net/gsoap2/gsoap_%{version}.tar.gz

Patch1: gsoap-opensslv1.patch

BuildRequires: flex
BuildRequires: bison
BuildRequires: findutils
BuildRequires: openssl-devel
BuildRequires: libtool

Requires: openssl

%define installdir /opt/gsoap-opensslv1
%define my_bindir %installdir/bin
%define my_mandir %installdir/share/man
%define my_libdir %installdir/lib64
%define my_datadir %installdir/share
%define my_includedir %installdir/include


%description

=======================================================================

Modified version of gSOAP which has the gsoap-opensslv1.patch applied, 
and which installs into /opt/gsoap-opensslv1

This package provides static libraries.

=======================================================================

The gSOAP Web services development toolkit offers an XML to C/C++
language binding to ease the development of SOAP/XML Web services in C
and C/C++.

%prep
%setup -q -n gsoap-2.7
%patch1 -p1

%build

./configure --prefix=%installdir --libdir=%my_libdir
make

%install

rm -rf %{buildroot}
make install DESTDIR=%{buildroot}

%clean
rm -rf %{buildroot}

%check
make check

%files
%doc README.txt NOTES.txt LICENSE.txt
%my_bindir/soapcpp2
%my_bindir/wsdl2h
%my_libdir/libgsoap*.a
%my_includedir/stdsoap2.h
%dir %my_datadir/gsoap
%dir %my_datadir/gsoap/import
%my_datadir/gsoap/import/c14n.h
%my_datadir/gsoap/import/dom.h
%my_datadir/gsoap/import/ds2.h
%my_datadir/gsoap/import/ds.h
%my_datadir/gsoap/import/README.txt
%my_datadir/gsoap/import/soap12.h
%my_datadir/gsoap/import/stldeque.h
%my_datadir/gsoap/import/stl.h
%my_datadir/gsoap/import/stllist.h
%my_datadir/gsoap/import/stlset.h
%my_datadir/gsoap/import/stlvector.h
%my_datadir/gsoap/import/wsa3.h
%my_datadir/gsoap/import/wsa4.h
%my_datadir/gsoap/import/wsa5.h
%my_datadir/gsoap/import/wsa.h
%my_datadir/gsoap/import/WS-example.c
%my_datadir/gsoap/import/WS-example.h
%my_datadir/gsoap/import/WS-Header.h
%my_datadir/gsoap/import/wsp.h
%my_datadir/gsoap/import/wsrp.h
%my_datadir/gsoap/import/wsse2.h
%my_datadir/gsoap/import/wsse.h
%my_datadir/gsoap/import/wsu.h
%my_datadir/gsoap/import/xlink.h
%my_datadir/gsoap/import/xmime4.h
%my_datadir/gsoap/import/xmime5.h
%my_datadir/gsoap/import/xmime.h
%my_datadir/gsoap/import/xml.h
%my_datadir/gsoap/import/xmlmime5.h
%my_datadir/gsoap/import/xmlmime.h
%my_datadir/gsoap/import/xop.h
%dir %my_datadir/gsoap/WS
%my_datadir/gsoap/WS/README.txt
%my_datadir/gsoap/WS/WS-Addressing.xsd
%my_datadir/gsoap/WS/WS-Addressing03.xsd
%my_datadir/gsoap/WS/WS-Addressing04.xsd
%my_datadir/gsoap/WS/WS-Addressing05.xsd
%my_datadir/gsoap/WS/WS-Discovery.wsdl
%my_datadir/gsoap/WS/WS-Enumeration.wsdl
%my_datadir/gsoap/WS/WS-Policy.xsd
%my_datadir/gsoap/WS/WS-Routing.xsd
%my_datadir/gsoap/WS/WS-typemap.dat
%my_datadir/gsoap/WS/discovery.xsd
%my_datadir/gsoap/WS/ds.xsd
%my_datadir/gsoap/WS/enumeration.xsd
%my_datadir/gsoap/WS/typemap.dat
%my_datadir/gsoap/WS/wsse.xsd
%my_datadir/gsoap/WS/wsu.xsd
%dir %my_datadir/gsoap/custom
%my_datadir/gsoap/custom/README.txt
%my_datadir/gsoap/custom/long_double.c
%my_datadir/gsoap/custom/long_double.h
%my_datadir/gsoap/custom/struct_timeval.c
%my_datadir/gsoap/custom/struct_timeval.h
%my_datadir/gsoap/custom/struct_tm.c
%my_datadir/gsoap/custom/struct_tm.h
%dir %my_datadir/gsoap/plugin
%my_datadir/gsoap/plugin/README.txt
%my_datadir/gsoap/plugin/cacerts.c
%my_datadir/gsoap/plugin/cacerts.h
%my_datadir/gsoap/plugin/httpda.c
%my_datadir/gsoap/plugin/httpda.h
%my_datadir/gsoap/plugin/httpdatest.c
%my_datadir/gsoap/plugin/httpdatest.h
%my_datadir/gsoap/plugin/httpform.c
%my_datadir/gsoap/plugin/httpform.h
%my_datadir/gsoap/plugin/httpget.c
%my_datadir/gsoap/plugin/httpget.h
%my_datadir/gsoap/plugin/httpgettest.c
%my_datadir/gsoap/plugin/httpgettest.h
%my_datadir/gsoap/plugin/httpmd5.c
%my_datadir/gsoap/plugin/httpmd5.h
%my_datadir/gsoap/plugin/httpmd5test.c
%my_datadir/gsoap/plugin/httpmd5test.h
%my_datadir/gsoap/plugin/httppost.c
%my_datadir/gsoap/plugin/httppost.h
%my_datadir/gsoap/plugin/logging.c
%my_datadir/gsoap/plugin/logging.h
%my_datadir/gsoap/plugin/md5evp.c
%my_datadir/gsoap/plugin/md5evp.h
%my_datadir/gsoap/plugin/plugin.c
%my_datadir/gsoap/plugin/plugin.h
%my_datadir/gsoap/plugin/smdevp.c
%my_datadir/gsoap/plugin/smdevp.h
%my_datadir/gsoap/plugin/threads.c
%my_datadir/gsoap/plugin/threads.h
%my_datadir/gsoap/plugin/wsaapi.c
%my_datadir/gsoap/plugin/wsaapi.h
%my_datadir/gsoap/plugin/wsse2api.c
%my_datadir/gsoap/plugin/wsse2api.h
%my_datadir/gsoap/plugin/wsseapi.c
%my_datadir/gsoap/plugin/wsseapi.h
%my_libdir/pkgconfig/gsoapck.pc
%my_libdir/pkgconfig/gsoapck++.pc
%my_libdir/pkgconfig/gsoap.pc
%my_libdir/pkgconfig/gsoap++.pc
%my_libdir/pkgconfig/gsoapssl.pc
%my_libdir/pkgconfig/gsoapssl++.pc
# Additions in 2.7.12-1
%my_datadir/gsoap/WS/WS-ReliableMessaging.wsdl
%my_datadir/gsoap/WS/WS-ReliableMessaging.xsd
%my_datadir/gsoap/WS/reference-1.1.xsd
%my_datadir/gsoap/WS/ws-reliability-1.1.xsd
%my_datadir/gsoap/import/ref.h
%my_datadir/gsoap/import/wsrm.h
%my_datadir/gsoap/import/wsrm4.h
%my_datadir/gsoap/import/wsrx.h
# Additions in 2.7.13-1
%my_datadir/gsoap/import/stdstring.h
%my_datadir/gsoap/import/xsd.h
%my_datadir/gsoap/plugin/wsseapi.cpp
#
# other files produced by this build not in the above file list from the CentOS spec file
%my_datadir/gsoap/extras/README.txt
%my_datadir/gsoap/extras/ckdb.c
%my_datadir/gsoap/extras/ckdb.h
%my_datadir/gsoap/extras/ckdbtest.c
%my_datadir/gsoap/extras/ckdbtest.h
%my_datadir/gsoap/extras/fault.cpp
%my_datadir/gsoap/extras/logging.cpp
%my_datadir/gsoap/extras/soapdefs.h
%my_datadir/gsoap/plugin/httpposttest.c
%my_datadir/gsoap/plugin/httpposttest.h


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%changelog

* Sat Dec  7 2019 Alan Iwi <alan.iwi@stfc.ac.uk> - 2.7.15-1
- partially based on CentOS7 spec file for 2.8.16 but stripped right back to vanilla build without their patches etc
- does not create shared libraries and does not use sub-packages
- use package name gsoap-opensslv1-static so it can coexist with standard gsoap package
  (and hard-code "gsoap" in a few places where %{name} was used)
- include the gsoap2-opensslv1 patch
- make it install into /opt/gsoap-opensslv1, as follows:
   - use plain "./configure" instead of the configure macro (which does install into /usr)
     except add --libdir flag to make it use "lib64" instead of "lib" subdirectory
   - add --prefix=/opt/gsoap-opensslv1
